package ru.dbotthepony.mc.otm.block.entity;

import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.capability.MatteryMachineEnergyStorage;
import ru.dbotthepony.mc.otm.container.MatteryContainer;
import ru.dbotthepony.mc.otm.menu.DriveViewerMenu;

import javax.annotation.Nullable;
import java.math.BigDecimal;

public class BlockEntityDriveViewer extends BlockEntityMatteryPowered {
	public BlockEntityDriveViewer(BlockPos p_155229_, BlockState p_155230_) {
		super(Registry.BlockEntities.DRIVE_VIEWER, p_155229_, p_155230_);
		energy = new MatteryMachineEnergyStorage(this, MatteryMachineEnergyStorage.MachineType.WORKER, new BigDecimal(30_000));
	}

	private static final TranslatableComponent NAME = new TranslatableComponent("block.overdrive_that_matters.drive_viewer");

	public final MatteryContainer drive_slot = new MatteryContainer(this::setChanged, 1);

	@Override
	protected Component getDefaultDisplayName() {
		return NAME;
	}

	@Nullable
	@Override
	public AbstractContainerMenu createMenu(int containerID, Inventory inventory, Player ply) {
		return new DriveViewerMenu(containerID, inventory, this);
	}

	@Override
	public CompoundTag save(CompoundTag nbt) {
		nbt.put("drive_slot", drive_slot.serializeNBT());
		return super.save(nbt);
	}

	@Override
	public void load(CompoundTag nbt) {
		super.load(nbt);
		drive_slot.deserializeNBT(nbt.get("drive_slot"));
	}
}
