package ru.dbotthepony.mc.otm.network;

import net.minecraft.client.Minecraft;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.DistExecutor;
import net.minecraftforge.fmllegacy.network.NetworkEvent;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.network.android.AndroidBatteryPacket;

import java.util.function.Supplier;

public record SetCarriedPacket(ItemStack carried) {
	public void write(FriendlyByteBuf buffer) {
		buffer.writeItem(carried);
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> {
			if (Minecraft.getInstance().player.containerMenu != null) {
				Minecraft.getInstance().player.containerMenu.setCarried(carried);
			}
		});
	}

	public static SetCarriedPacket read(FriendlyByteBuf buffer) {
		return new SetCarriedPacket(buffer.readItem());
	}
}
