package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.menu.MatterDecomposerMenu;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;
import ru.dbotthepony.mc.otm.menu.widget.GaugeWidget;
import ru.dbotthepony.mc.otm.screen.panels.*;

import javax.annotation.Nullable;
import java.util.List;

public class MatterDecomposerScreen extends MatteryScreen<MatterDecomposerMenu> implements MatteryScreen.IMatteryScreenGaugeGetter, MatteryScreen.IMatteryScreenBatteryGetter, MatteryScreen.IMatteryScreenGridBased {
	public MatterDecomposerScreen(MatterDecomposerMenu p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);
	}

	@Override
	public List<GaugeWidget> getGauges() {
		return List.of(menu.battery_widget, menu.matter_widget);
	}

	@Override
	public List<MatterySlot> getBatterySlots() {
		return List.of(menu.battery_slot);
	}

	@Override
	public void createGridPanels(FlexGridPanel grid) {
		new SlotPanel<>(this, grid, 0, 0, menu.input).setDockMargin(2, 0, 2, 0);
		new MatteryWidgetPanel(this, grid, menu.progress).setDockMargin(2, 0, 2, 0);
		new SlotPanel<>(this, grid, 0, 0, menu.output).setDockMargin(2, 0, 2, 0);
	}
}
